//---------------------------------------------------------------------------
//
//	KPED	-Ktl Pixel EDitor-
//
//		BMP file plugin
//
//			(C)2000
//			Kita Yoshikazu
//
//---------------------------------------------------------------------------
#include <stdio.h>
#include "../kplginbase.h"
#pragma hdrstop

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	return 1;
}

//---------------------------------------------------------------------------
void GetInfo(KPIinf *inf)
{
	wsprintf(inf->ext, ".BMP;.DIB");
	wsprintf(inf->kind, "rbg}bvf[^(*.bmp)");
}
//---------------------------------------------------------------------------
int GetData(char *file, KPIhead *head)
{
	BITMAPFILEHEADER bmf;
	BITMAPINFOHEADER bmi;
	FILE *fd;
	if((fd = fopen(file, "rb")) == NULL)
		return(FALSE);
	fread(&bmf, 1, sizeof(BITMAPFILEHEADER), fd);
	fread(&bmi, 1, sizeof(BITMAPINFOHEADER), fd);
	fclose(fd);

	if((bmf.bfType != ('M'<<8|'B'))||(bmi.biBitCount != 8))
	{
		MessageBox(NULL, "̃t@C256FBMPt@Cł͂܂B", "BMP[hG[", MB_OK|MB_ICONWARNING);
		return(FALSE);
	}

	head->w = bmi.biWidth;
	head->h = bmi.biHeight;
	head->depth = bmi.biBitCount;
	head->anmst = 0;
	head->anmfs = 0;	//Aj
	return(TRUE);
}
//---------------------------------------------------------------------------
int Load(char *file, KPIdat *data)
{
	BITMAPFILEHEADER bmf;
	BITMAPINFOHEADER bmi;
	FILE *fd;
	if((fd = fopen(file, "rb")) == NULL)
		return(FALSE);
	fread(&bmf, 1, sizeof(BITMAPFILEHEADER), fd);
	fread(&bmi, 1, sizeof(BITMAPINFOHEADER), fd);

	//pbg̓ǂݍ
	fread(data->pal, 256, sizeof(RGBQUAD), fd);
	//摜̓ǂݍ(㉺])
	for(int i = bmi.biHeight-1;i >= 0;i--)
		fread(&(data->dat[i*bmi.biWidth]), 1, bmi.biWidth, fd);

	return(TRUE);
}
//---------------------------------------------------------------------------
int Save(char *file, KPIhead *head, KPIdat *data)
{
	BITMAPFILEHEADER bmf;
	BITMAPINFOHEADER bmi;
	FILE *fd;

	bmf.bfType = (WORD)(('M'<<8)|'B');
	bmf.bfReserved1 = bmf.bfReserved2 = 0;
	bmf.bfOffBits = sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)
		+sizeof(RGBQUAD)*256;
	bmf.bfSize = bmf.bfOffBits + head->w*head->h;

	bmi.biSize = sizeof(BITMAPINFOHEADER);
	bmi.biWidth = head->w;
	bmi.biHeight = head->h;
	bmi.biPlanes = 1;
	bmi.biBitCount = (WORD)head->depth;
	bmi.biCompression = 0;
	bmi.biSizeImage = head->w * head->h;
	bmi.biXPelsPerMeter = bmi.biYPelsPerMeter = 0;
	bmi.biClrUsed = 0;
	bmi.biClrImportant = 0;

	if((fd = fopen(file, "wb")) == NULL)
		return(FALSE);
	fwrite(&bmf, 1, sizeof(BITMAPFILEHEADER), fd);
	fwrite(&bmi, 1, sizeof(BITMAPINFOHEADER), fd);
	fwrite(data->pal, 256, sizeof(RGBQUAD), fd);
	for(int i = bmi.biHeight-1;i >= 0;i--)
		fwrite(&(data->dat[i*bmi.biWidth]), 1, bmi.biWidth, fd);
	fclose(fd);

	return(TRUE);
}
//---------------------------------------------------------------------------
