//---------------------------------------------------------------------------
//
//	KPED	-Ktl Pixel EDitor-
//
//			(C)2000
//			Kita Yoshikazu
//
//---------------------------------------------------------------------------
#include <windows.h>
#include "../kplgtlbase.h"
#include "resource.h"
#pragma hdrstop

//---------------------------------------------------------------------------
#define	PEN_SIZE_MIN	1
#define	PEN_SIZE_MAX	100
#define	PEN_SIZE_PAGE	20

//---------------------------------------------------------------------------
typedef struct _pendat
{
	int		x, y;
	int		size;
	SCROLLINFO	sinfo;
} pendat;
//---------------------------------------------------------------------------
LRESULT CALLBACK ToolDLG(HWND hdlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	KPTarg *arg;
	pendat *log;
	void *cur;
	//bZ[Wɏ]
	switch(uMsg)
	{
	case WM_INITDIALOG:
		//Ə|C^̕ۑ
		SetWindowLong(hdlg,GWL_USERDATA,(LONG)lParam);
		if((arg = (KPTarg *)GetWindowLong(hdlg,GWL_USERDATA)) == NULL)
			return(FALSE);
		//GfBbg
		log = (pendat*)*(arg->user);
		SetScrollInfo(hdlg, IDC_SIZESLD, &(log->sinfo), TRUE);
		SetDlgItemInt(hdlg, IDC_SIZEEDIT, log->size, TRUE);
		break;
	case WM_HSCROLL:
		//Ə|C^Qbg
		if((arg = (KPTarg *)GetWindowLong(hdlg,GWL_USERDATA)) == NULL)
			return(FALSE);
		log = (pendat*)*(arg->user);

		//Jg摜̃Qbg
		cur = arg->ext->getcur(arg->ext->Own);
		if(cur != NULL) arg->ext->Own = cur;
		//Jg̃Qbg
		arg->ext->getnew(arg->ext->Own, arg->dat);

		//bZ[Wɂs
		switch(LOWORD(wParam))
		{
		case SB_LINELEFT:
			if(log->size > PEN_SIZE_MIN) log->size--;
			break;
		case SB_LINERIGHT:
			if(log->size < PEN_SIZE_MAX) log->size++;
			break;
		case SB_PAGELEFT:
			log->size -= PEN_SIZE_PAGE;
			if(log->size < PEN_SIZE_MIN) log->size = PEN_SIZE_MIN;
			break;
		case SB_PAGERIGHT:
			log->size += PEN_SIZE_PAGE;
			if(log->size >= PEN_SIZE_MAX)
				log->size = PEN_SIZE_MAX-1;
			break;
		case SB_THUMBPOSITION:
		case SB_THUMBTRACK:
			log->size = (int)(HIWORD(wParam));
			if(log->size < PEN_SIZE_MIN) log->size = PEN_SIZE_MIN;
			break;
		}
		log->sinfo.nPos = log->size;
		SetScrollInfo(hdlg, IDC_SIZESLD, &(log->sinfo), TRUE);
		SetDlgItemInt(hdlg, IDC_SIZEEDIT, log->size, TRUE);
		break;
	case WM_CLOSE:
		EndDialog(hdlg,IDOK);
		break;
	default:
		return(FALSE);
	}
	return(TRUE);

}
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	return 1;
}
//---------------------------------------------------------------------------
void Info(char *kind, void **user)
{
	wsprintf(kind, "Mc[");
	//̊֐͊ǗKxĂяô
	//œƎ̊mۂsĂ܂B
	if(*user == NULL)
		*user = new pendat;
	pendat *log = (pendat*)*user;
	log->size = 1;
	log->sinfo.cbSize = sizeof(SCROLLINFO);
	log->sinfo.fMask = SIF_POS|SIF_RANGE|SIF_PAGE;
	log->sinfo.nMin = PEN_SIZE_MIN;
	log->sinfo.nMax = PEN_SIZE_MAX;
	log->sinfo.nPage = PEN_SIZE_PAGE;
	log->sinfo.nPos = 1;
}
//---------------------------------------------------------------------------
void Down(KPTarg *arg)
{
	//NbNꂽ_ύX
	KPTdat *dat = arg->dat;
	pendat *log = (pendat*)*(arg->user);
	dat->Data[dat->Y*dat->W+dat->X] = (uchar)dat->Idx;
	//̊Jn_m
	log->x = dat->X;
	log->y = dat->Y;
	//ʂ̏̕
	RECT r = {dat->X, dat->Y, dat->X+1, dat->Y+1};
	arg->ext->redraw(arg->ext->Own, &r);
}
//---------------------------------------------------------------------------
void Drag(KPTarg *arg)
{
	KPTdat *dat = arg->dat;
	pendat *log = (pendat*)*(arg->user);

	//HDCm
	HDC hdc;
	HBITMAP dib;
	hdc = CreateCompatibleDC(NULL);
	dib = (HBITMAP)SelectObject(hdc, dat->Hbmp);

	//y̍쐬An_ʒu̕ύX
	HPEN hpen, hpenbak;
	RGBQUAD col;
	LOGBRUSH lb;
	col = dat->Pal[dat->Idx];
	lb.lbStyle = BS_SOLID;
	lb.lbColor = RGB(col.rgbRed, col.rgbGreen, col.rgbBlue);
	hpen = ExtCreatePen(PS_GEOMETRIC|PS_SOLID, log->size, &lb, 0, NULL);
	hpenbak = (HPEN)SelectObject(hdc, hpen);
	//`
	MoveToEx(hdc, log->x, log->y, NULL);
	LineTo(hdc, dat->X, dat->Y);
	SelectObject(hdc, hpenbak);
	DeleteObject(hpen);

	//I
	SelectObject(hdc, dib);
	DeleteDC(hdc);

	//ʂ̏̕
	RECT r;
	if(log->x < dat->X)
		{r.left = log->x-log->size;r.right = dat->X+log->size;}
	else	{r.left = dat->X-log->size;r.right = log->x+log->size;}
	if(log->y < dat->Y)
		{r.top = log->y-log->size;r.bottom = dat->Y+log->size;}
	else	{r.top = dat->Y-log->size;r.bottom = log->y+log->size;}
	arg->ext->redraw(arg->ext->Own, &r);

	//VꏊɎn_ړ
	log->x = dat->X;
	log->y = dat->Y;
}
//---------------------------------------------------------------------------
void Up(KPTarg *arg)
{
	//ɂ邱Ƃ͂Ȃ̂ŋ֐łB
	//Ă܂Ă̓vOCƂĕŝ
	//vOCƂĔF܂̂ŒӂĂB
}
//---------------------------------------------------------------------------
void Dialog(KPTarg *arg)
{
	CreateDialogParam(arg->ext->Inst, MAKEINTRESOURCE(IDD_DLGPEN), arg->ext->Wnd, (DLGPROC)ToolDLG,(LPARAM)arg);
}
//---------------------------------------------------------------------------
